-----------------------------------------------------------------------------------------------
-- Client Lua Script for FrenemyTelegraphs
-- Copyright (c) Tyler T. Hardy 2014. All rights reserved
-----------------------------------------------------------------------------------------------
 
require "Window"
 
-----------------------------------------------------------------------------------------------
-- FrenemyTelegraphs Module Definition
-----------------------------------------------------------------------------------------------
local FrenemyTelegraphs = {} 
 
-----------------------------------------------------------------------------------------------
-- Constants
-----------------------------------------------------------------------------------------------
-- e.g. local kiExampleVariableMax = 999
 
-----------------------------------------------------------------------------------------------
-- Initialization
-----------------------------------------------------------------------------------------------
function FrenemyTelegraphs:new(o)
    o = o or {}
    setmetatable(o, self)
    self.__index = self 

    -- initialize variables here

    return o
end

function FrenemyTelegraphs:Init()
	local bHasConfigureFunction = false
	local strConfigureButtonText = ""
	local tDependencies = {
		-- "UnitOrPackageName",
	}
    Apollo.RegisterAddon(self, bHasConfigureFunction, strConfigureButtonText, tDependencies)
end
 

-----------------------------------------------------------------------------------------------
-- FrenemyTelegraphs OnLoad
-----------------------------------------------------------------------------------------------
function FrenemyTelegraphs:OnLoad()
	Apollo.RegisterEventHandler("UnitPvpFlagsChanged", "OnUnitChangedPvp", self)
	Apollo.RegisterEventHandler("CharacterCreated", "OnCharacterCreated", self)
	
	if GameLib.GetPlayerUnit() then
		self:OnCharacterCreated()
	else
		Apollo.RegisterEventHandler("CharacterCreated", "OnCharacterLoaded", self)
	end

    -- load our form file
--[[	self.xmlDoc = XmlDoc.CreateFromFile("FrenemyTelegraphs.xml")
	self.xmlDoc:RegisterCallback("OnDocLoaded", self)]]--
end

-----------------------------------------------------------------------------------------------
-- FrenemyTelegraphs OnDocLoaded
-----------------------------------------------------------------------------------------------
--[[function FrenemyTelegraphs:OnDocLoaded()

	if self.xmlDoc ~= nil and self.xmlDoc:IsLoaded() then
	    self.wndMain = Apollo.LoadForm(self.xmlDoc, "FrenemyTelegraphsForm", nil, self)
		if self.wndMain == nil then
			Apollo.AddAddonErrorText(self, "Could not load the main window for some reason.")
			return
		end
		
	    self.wndMain:Show(false, true)

		-- if the xmlDoc is no longer needed, you should set it to nil
		-- self.xmlDoc = nil
		
		-- Register handlers for events, slash commands and timer, etc.
		-- e.g. Apollo.RegisterEventHandler("KeyDown", "OnKeyDown", self)


		-- Do additional Addon initialization here
	end
end]]--

-----------------------------------------------------------------------------------------------
-- FrenemyTelegraphs Functions
-----------------------------------------------------------------------------------------------
-- Define general functions here

function FrenemyTelegraphs:OnCharacterCreated()
	local unitPlayer = GameLib.GetPlayerUnit()
	
	if unitPlayer ~= nil then
		local bFlagged = GameLib.IsPvpFlagged()
		self:SetEnemyTelegraphs(bFlagged)
	end
end

function FrenemyTelegraphs:OnUnitChangedPvp(unit)
	if unit ~= GameLib.GetPlayerUnit() then return end
	
	local bFlagged = GameLib.IsPvpFlagged()
	
	self:SetEnemyTelegraphs(bFlagged)
end

function FrenemyTelegraphs:SetEnemyTelegraphs(bState)
	Apollo.SetConsoleVariable("spell.enemyPlayerTelegraphDisplay", bState)
end

-----------------------------------------------------------------------------------------------
-- FrenemyTelegraphsForm Functions
-----------------------------------------------------------------------------------------------
-- when the OK button is clicked
function FrenemyTelegraphs:OnOK()
	self.wndMain:Close() -- hide the window
end

-- when the Cancel button is clicked
function FrenemyTelegraphs:OnCancel()
	self.wndMain:Close() -- hide the window
end


-----------------------------------------------------------------------------------------------
-- FrenemyTelegraphs Instance
-----------------------------------------------------------------------------------------------
local FrenemyTelegraphsInst = FrenemyTelegraphs:new()
FrenemyTelegraphsInst:Init()
